glibmm: Gio::SocketControlMessage Class Reference

glibmm 2.45.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::SocketControlMessage Class Reference
Portable Network I/O Functionality

SocketControlMessage - A Socket control message. More...

`#include <giomm/socketcontrolmessage.h>`

Inheritance diagram for Gio::SocketControlMessage:
[legend]

## Public Member Functions
virtual | ~SocketControlMessage ()
GSocketControlMessage* | gobj ()
| Provides access to the underlying C GObject. More...
const GSocketControlMessage* | gobj () const
| Provides access to the underlying C GObject. More...
GSocketControlMessage* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
int | get_level () const
| Returns the "level" (i.e. the originating protocol) of the control message. More...
int | get_msg_type () const
| Returns the protocol specific type of the control message. More...
gsize | get_size () const
| Returns the space required for the control message, not including headers or alignment. More...
void | serialize (gpointer data)
| Converts the data in the message to bytes placed in the message. More...
virtual gsize | get_size_vfunc () const
virtual int | get_level_vfunc () const
virtual int | get_type_vfunc () const
virtual void | serialize_vfunc (gpointer data)
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable ()
| trackable (const trackable &src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< SocketControlMessage > | deserialize (int level, int type, gsize size, gpointer data)
| Tries to deserialize a socket control message of a given level and type. More...

## Protected Member Functions
| SocketControlMessage ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::SocketControlMessage > | wrap (GSocketControlMessage* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify) (gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

SocketControlMessage - A Socket control message.

A SocketControlMessage is a special-purpose utility message that can be sent to or received from a Socket. These types of messages are often called "ancillary data".

The message can represent some sort of special instruction to or information from the socket or can represent a special kind of transfer to the peer (for example, sending a file description over a UNIX socket).

These messages are sent with Gio::Socket::send() and received with Gio::Socket::receive().

To extend the set of control message that can be sent, subclass this class and override the get_size, get_level, get_type and serialize methods.

To extend the set of control messages that can be received, subclass this class and implement the deserialize method. Also, make sure your class is registered with the GType typesystem before calling Gio::Socket::receive() to read such a message.

Since glibmm 2.28:

## Constructor & Destructor Documentation

virtual Gio::SocketControlMessage::~SocketControlMessage | ( |  | ) |
| virtual

Gio::SocketControlMessage::SocketControlMessage | ( |  | ) |
| protected

## Member Function Documentation

static Glib::RefPtr<SocketControlMessage> Gio::SocketControlMessage::deserialize | ( | int | level,
|  | int | type,
|  | gsize | size,
|  | gpointer | data
| ) |  |
| static

Tries to deserialize a socket control message of a given level and type.

This will ask all known (to GType) subclasses of SocketControlMessage if they can understand this kind of message and if so deserialize it into a SocketControlMessage.

If there is no implementation for this kind of control message, `0` will be returned.

Since glibmm 2.22:

Parameters

  level | A socket level.
  type | A socket control message type for the given level.
  size | The size of the data in bytes.
  data | Pointer to the message data.

Returns
  The deserialized message or `0`.

int Gio::SocketControlMessage::get_level | ( |  | ) | const

Returns the "level" (i.e. the originating protocol) of the control message.

This is often SOL_SOCKET.

Since glibmm 2.22:

Returns
  An integer describing the level.

virtual int Gio::SocketControlMessage::get_level_vfunc | ( |  | ) | const
| virtual

int Gio::SocketControlMessage::get_msg_type | ( |  | ) | const

Returns the protocol specific type of the control message.

For instance, for UNIX fd passing this would be SCM_RIGHTS.

Since glibmm 2.22:

Returns
  An integer describing the type of control message.

gsize Gio::SocketControlMessage::get_size | ( |  | ) | const

Returns the space required for the control message, not including headers or alignment.

Since glibmm 2.22:

Returns
  The number of bytes required.

virtual gsize Gio::SocketControlMessage::get_size_vfunc | ( |  | ) | const
| virtual

static GType Gio::SocketControlMessage::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

virtual int Gio::SocketControlMessage::get_type_vfunc | ( |  | ) | const
| virtual

GSocketControlMessage* Gio::SocketControlMessage::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GSocketControlMessage* Gio::SocketControlMessage::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GSocketControlMessage* Gio::SocketControlMessage::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Gio::SocketControlMessage::serialize | ( | gpointer | data | ) |

Converts the data in the message to bytes placed in the message.

data is guaranteed to have enough space to fit the size returned by g_socket_control_message_get_size() on this object.

Since glibmm 2.22:

Parameters

  data | A buffer to write data to.

virtual void Gio::SocketControlMessage::serialize_vfunc | ( | gpointer | data | ) |
| virtual

## Friends And Related Function Documentation

Glib::RefPtr< Gio::SocketControlMessage > wrap | ( | GSocketControlMessage * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.